package com.changhong.epc.form.execute;

import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.changhong.autoform.entity.ProcessBudget;
import com.changhong.epc.bean.form.BugetSubForm;
import com.changhong.epc.bean.form.Fieldsets;
import com.changhong.epc.bean.form.FormType;
import com.changhong.epc.bean.tenant.cost.budgetlog.IBillCostLog;
import com.changhong.epc.constter.parsing.journey.JourneyKey;
import com.changhong.epc.form.execute.BudgetRecord.BudgetMoney;

/**
 * 引用其他组件
 * @author wangZX
 *
 */
public interface IFormOthersOperation  extends JourneyKey{
	
	
	String BX_AMOUNT = "bxAmount";
	String SQ_AMOUNT = "sqAmount";
	String YS_SURPLUS_AMOUNT = "ysSurplusAmount";
	String YS_SUM_AMOUNT = "ysSummount";
	
	/**
	 * 获得当前单据类型( BX预算，SQ申请，BX报销)
	 * @return
	 */
	public FormType getBillType(ProcessBudget processBudget);
	
	/**
	 * 查询预算单子表单,根据费用类型
	 * @param processBudget
	 * @param costType
	 * @return
	 */
	public List<BugetSubForm> queryBudgetByCostTypeAndParentId(ProcessBudget processBudget, HashSet<String> costType);
	
	/**
	 * 获得当点表单对用的费用类型（交通费，住宿费）
	 */
	public String getBillCostType(ProcessBudget processBudget);
	
	/**
	 * 记录日志
	 * @param log
	 * @return
	 */
	public Object recordLog(Object log);
	
	/**
	 * 查询表单数据详细
	 * @param processBudget
	 * @return
	 */
	public Map<String,Object> getFromInfo(ProcessBudget processBudget);
	
	/**
	 * 查询表单结构详情 
	 * @param processBudget
	 * @return
	 */
	public Fieldsets getFormFieldProperty(ProcessBudget processBudget);
	
	/**
	 * 更改数据
	 * @param formData
	 */
	public void updateFormFieldProperty(ProcessBudget processBudget, BudgetMoney data);
	
	/**
	 * 更改数据
	 * @param processBudget
	 * @param param
	 */
	public void updateFormFieldProperty(ProcessBudget processBudget, Map<String,Object> param,FormType formType ,IBillCostLog IBillCostLog);
	
	/**
	 * 获取申请 预算金额 MdCode
	 * @return
	 */
	public String getMoneyAppleyMoneyMdCode();
	
	/**
	 * 获得报销金额金额 主数据
	 * @return
	 */
	public String getMoneyCpnMdCode();
	
	/**
	 * 获得预算总额 主数据
	 */
	public String getBudgetSumMoneyMdCode();
	
	/**
	 * 获得预算余额 主数据
	 * @return
	 */
	public String getBudgetBalanceMdCode();
	
	
	/**
	 * 查询单条详细信息
	 * @param processBudget
	 * @return
	 */
	public Map<String,Object> selectFormDataInfo(ProcessBudget processBudget);
	
	}
