package com.changhong.epc.form.mapper.tenant;

import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import com.changhong.epc.bean.form.ApplyCostForm;
import com.changhong.epc.bean.tenant.cost.CostFromMapping;
import org.apache.ibatis.annotations.Param;

import com.changhong.epc.bean.form.BugetSubForm;
import com.changhong.epc.bean.form.FormDataEntity;
import com.changhong.epc.bean.form.ProcessState;
import com.changhong.epc.form.service.budget.department.util.AddMoney;
import com.changhong.epc.form.service.budget.department.util.ContractStage;

public interface FormDataMapper  {
	
	int updataFormByCustom(@Param("formName")String formName, @Param("dataRowNum")int dataRowNum, @Param("fields")Map<String, Object> fields);
	
	/**
	 * 查看详情时 向报销单中添加orderCode 更新报销单状态
	 */
	int updateExpendFormIfHaveOrderCode(@Param("formName") String formName, @Param("dataRowNum") Integer dataRowNum, @Param("orderCode")String orderCode);
	
	/**
	 * 修改报销单状态
	 */
	int updateExpendFormState(@Param("voucherCode") String voucherCode,@Param("formName") String formName, @Param("dataRowNum") Integer dataRowNum, @Param("status")Integer status);

	/**
	 * 查询表单数据
	 * 
	 */
	Map<String,Object> searchFormData(FormDataEntity formData);

	/**
	 * 查询子表单
	 * @param formData
	 * @return
	 */
	List<Map<String,Object>> searchSubFormDataList(FormDataEntity formData);
	
	List<Map<String,Object>> searchFormDataList(FormDataEntity formData);
	
	List<BugetSubForm> searchBudgetSubForm(FormDataEntity formData, HashSet<?> costType);
	
	/**
	 * 查询追加（退回）预算表数据 
	 */
	List<AddMoney> searchExtendFormData(@Param("formName") String formName,
			@Param("parentDataRowNum") String parentDataRowNum,
			@Param("dataRowNum") String dataRowNum);
	
	/**
	 * 修改未还金额/以还金额 
	 */
	int updaterepayment(@Param("formName") String formName, 
			@Param("OutstandingAmount") Integer OutstandingAmount,
			@Param("alreadyRepaid") Integer alreadyRepaid, 
			@Param("dataRowNum") Integer dataRowNum);
	
	/**
	 * 删除表单数据
	 */
	int deleteFormData(FormDataEntity formData);
	
	/**
	 * 新增表单数据
	 */
	Integer insertFormData(FormDataEntity formData);
	
	/**
	 * 修改表单数据
	 */
    int updateFormData(FormDataEntity formData);
    
    /**
	 * 查询一条上级预算
	 * 
	 */
	Map<String,Object> selectBudget(@Param("orgs") String orgs,@Param("budget_itemCostType") String budget_itemCostType,@Param("formName")String formName);
    
    /**
     * 修改余额
     * 
     */
    int updateItemBalance(@Param("add") AddMoney add,@Param("formName") String formName);
    
    List<Integer> selectRangeByIds(@Param("formName")String formName,
    		@Param("formDate")String formDate,
    		@Param("toDate")String toData,
    		@Param("budgetProject")String budType,
    		@Param("currency")String currency,
    		@Param("conditionMap")Map<String,Object> conditionMap,
    		@Param("occupy") String occupy,//占用还是使用
    		@Param("budProject") String budProject,//项目预算值
    		@Param("budDep") String budDep,//部门预算值
    		@Param("asdasd") Integer asdasdasd,//pageNum
    		@Param("easdadsasdasd") Integer zxczsa//pageSize
    	
    		);

    
	List<Integer> selectMainIdBySubIds(@Param("formName") String formName, 
									 @Param("dataRowNumber") String dataRowNumber);
    
/**
	 * 根据日期检查数据格式
	 * @param formName
	 * @param startDate
	 * @param endDate
	 * @param currency
	 * @return
	 */	List<Integer> checkDate(@Param("formName") String formName ,@Param("startDate") String startDate, @Param("endDate") String endDate, @Param("currency") String currency);
	
	List<Map<String,Object>> queryFormByDataRowNum(@Param("formName")String formName, @Param("dataRowNum") List<Integer> dataRowNum);

	List<ContractStage> selectSonForm(@Param("name") String formName,@Param("num") Integer dataRowNum);
	
	List<ContractStage> selectSonsForm(@Param("name") String formName,@Param("num") Integer dataRowNum);

	
	Integer updateContract(@Param("son") ContractStage con,@Param("name") String formName);
	
	Integer selectDataRowNum(@Param("formId") Object formId,@Param("tenantId") Object tenantId,@Param("orderCode") Object orderCode);
	
	/**
	 * 修改表单流程状态
	 * @param pro
	 * @param formId
	 * @param tenantId
	 * @return
	 */
	Integer updateState(@Param("pro") ProcessState pro);
	
	/**
	 * 查询流程大状态
	 */
	ProcessState selectState(@Param("pro") ProcessState process);
	
	List<Map<String,Object>> searchFormDataLists(FormDataEntity formData);

	List<Integer> searchSubFormIds(@Param("formName") String formName, @Param("dataRowNum") Integer dataRowNum);
	
	/**
	 * 函数使用
	 */
	/**
	 * 查询表单数据
	 * 
	 */
	Map<String,Object> searchFormData1(FormDataEntity formData);
	
	/**
	 * 判断主表是否有重复
	 * @param formName
	 * @param formDate
	 * @param toData
	 * @param budType
	 * @param currency
	 * @return
	 */
	 List<Integer> selectRangeById(@Param("formName")String formName,
	    		@Param("formDate")String formDate,
	    		@Param("toDate")String toData,
	    		@Param("budgetProject")String budType,
	    		@Param("currency")String currency,
	    		@Param("occupy")String occupy
	    		);
	/**
	 * 查看当前单子明细中类型是否唯一
	 * @param formName
	 * @param formDate
	 * @param toData
	 * @param budType
	 * @param currency
	 * @return
	 */
	 List<Integer> selectRangeByIdOnlyOne(@Param("formName")String formName,
				@Param("subFormName")String subFormName,
				@Param("dataRowNum")List<BugetSubForm> dataRowNum,
				@Param("formDate")String formDate,
	    		@Param("toDate")String toData,
	    		@Param("budgetProject")String budType,
	    		@Param("currency")String currency,
	    		@Param("occupy")String occupy
	    		);

	 /**
	  * 判断子表单是否有重复
	  * 
	  */
	 String selectRangeByNumber(
			 @Param("C_Type")String C_Type,
			 @Param("dep")String dep,
			 @Param("budget_project")String budget_project,
			 @Param("formName")String formName,
			 @Param("list")List<Integer> selectRangeByIds
			 
			 );
	 
	 String selectByNumber(@Param("formName") String formName,@Param("id") String id,@Param("number") String number);
	 
	 
	 /**
	  * 
	  * 查询固定资产的原值
	  * zz
	  */
	 Map<String,String> selectAssetOri(@Param("tenantId") String tenantId,
											 @Param("formId")String formId,
											 @Param("assetId")String assetId);
	 
	 /**
	  * 预算单保存报销单编号    -----增
	  * zz
	  */
	 
	 int saveOccupant(@Param("tenantId") String tenantId,
			 @Param("formId")String formId,
			 @Param("dataRowNum")String dataRowNum,
			 @Param("reimbursement")String reimbursement);
	 
	 /**
	  * 预算单保存报销单编号    -----删
	  * zz
	  */
	 int delteOccupant(@Param("tenantId") String tenantId,
			 @Param("formId")String formId,
			 @Param("dataRowNum")String dataRowNum);
	 
	 /**
	  * 获取报销单所选择的申请单datarownum
	  * zz
	  */
	 Map<String , Object> selectToWriteBudgetByDataRowNum(@Param("formName")String formName,
															 @Param("dataRowNum")String dataRowNum);
	 
	 Map<String , Object> selectSQFormId(@Param("cId")String cId,@Param("fId")String fId);
	 
	 /**
	  * 查询编号用
	  * 
	  */
	 LinkedHashMap<String , Object> selectNumber(@Param("formName")String formName,
															 @Param("dataRowNum")String dataRowNum);
	 
	 
	 /**
	  * 总数
	  */
	int selectDataCountByUser(@Param("tenantId") String tenantId,
			 				@Param("formId")String formId,
			 				@Param("openId") String openId,
			 				@Param("costType") String costType);
	
	
	List<Map<String , Object>> selectDataListByUser(@Param("tenantId") String tenantId,
							@Param("formId")String formId,
							@Param("openId") String openId,
							@Param("costType") String costType,
							@Param("begin") String begin,
							@Param("size") String size);
	
	Map<String , Object> selectFormIdByCostTypeAndFormType(@Param("costType")String costType,
											@Param("formType") String formType);
	
	Map<String,Object> selectDataBybussinessNumber(@Param("formId")String formId,
							@Param("bussinessNumber")String bussinessNumber,
							@Param("tenantId") String tenantId);
	
	List<Map<String,Object>> getSumAlreadyPaid(@Param("formName")String formName,@Param("list")List<Integer> list);
	
	List<Integer> selectDataRows(@Param("formName") String formName
			,@Param("num")Integer dataRowNum
				,@Param("currDataRowNum")Integer currDataRowNum);

	/**
     * 根据openid查询所有为还玩的借款记录
	 * @param openId formName
	 * @return
	 * */
	List<Map<String,Object>> getPersionCostReturn(@Param("dateNum")Integer dateNum,
                                                  @Param("formName") String formName,
                                                  @Param("formName2") String formName2);

    List<Map<String,Object>> getBorrowMoney(@Param("openId")String openId,@Param("forName")String formName);

    Integer selectTableExist(@Param("formName")String formName);

	List<Map<String,Object>> selectApply(ApplyCostForm applyCostForm);

	/**
	 * 查询字段值 是否存在
	 */
	Integer selectValueCount(@Param("formName") String formName
			,@Param("fieKey") String fieKey
				,@Param("fieValue") String fieValue,@Param("dataRowNum") Integer dataRowNum);

    List<Map<String,Object>> searchSuperBudget(Map<String,Object> data);

	List<Map<String,Object>> searchBudget(Map<String,Object> data);

	Long searchSuperBudgetCount(Map<String,Object> data);

	/**
	 * 查询还款、借款数量
	 * @param repaymentFormId
	 * @param loanFormId
	 * @return
	 */
    int selectRepayment(@Param("borrowMoneyUser") String borrowMoneyUser, @Param("repaymentFormId") String repaymentFormId, @Param("loanFormId") String loanFormId, @Param("day") int day);

	/**
	 * 查询申请单id列表
	 * @return
	 */
	List<CostFromMapping> selectApplyFormIds();

	/**
	 * 查询申请单借款
	 * @param formIds
	 * @return
	 */
	int selectApplyRepayment(@Param("s") List<String> formIds, @Param("borrowMoneyUser") String borrowMoneyUser);
}
