package com.changhong.epc.form.mapper.tenant.apply;

import com.changhong.epc.bean.form.apply.ApplyMerge;
import com.changhong.epc.bean.form.apply.ApplyMergeDto;
import com.iemsoft.framework.cloud.mybatis.common.MybatisBaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;

public interface ApplyMergeMapper extends MybatisBaseMapper<ApplyMerge> {

    /**
     * 查询申请信息
     * @param dataRowNum
     * @return
     */
    Map<String,Object> selectApplyInfo(@Param("dataRowNum") int dataRowNum, @Param("formId") String formId);

    /**
     * 查询可合并用汇的申请信息
     * @param applyInfo
     * @return
     */
    List<Map<String,Object>> selectApplyMergeList(@Param("info") Map<String,Object> applyInfo, @Param("formId") String formId);

    /**
     * 根据id查询申请单列表
     * @param ids
     * @param formId
     * @return
     */
    List<Map<String,Object>> selectApplyMergeListByIds(@Param("ids") Collection<Integer> ids, @Param("formId") String formId);

    /**
     * 根据id查询申请单行程列表
     * @param ids
     * @param formId
     * @return
     */
    List<Map<String,Object>> selectApplyMergeChildList(@Param("ids") Collection<Integer> ids, @Param("formId") String formId);

    /**
     * 删除
     * @param dataRowNum
     * @return
     */
    int deleteByDataRowNum(int dataRowNum);

    /**
     * 获取结束的申请单的个数
     * @param applyMergeDto
     * @return
     */
    int countOverApply(ApplyMergeDto applyMergeDto);
}
