package com.changhong.epc.form.rest.Assets;

import com.changhong.epc.constter.form.utf.FormUrlConst;
import com.changhong.epc.form.service.assets.CalculationService;
import com.changhong.epc.rely.api.bean.Organization;
import lombok.Data;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * 固定资产
 */
@RestController
public class CalculationController implements FormUrlConst  {


	@Resource
	private CalculationService calculationService;

	/**
	 * 固定资产 折旧|计提
	 * @param calculationDto
	 * @return
	 */
	@PostMapping(UPDATA_DOACCRUED)
	public int depreciation(@RequestBody CalculationDto calculationDto){
		return calculationService.depreciation(calculationDto);
	}

	/**
	 * 固定资产 记账
	 * @param calculationDto
	 * @return
	 */
	@PostMapping(ASSETS_BUCHFUHRUNG)
	public int account(@RequestBody CalculationDto calculationDto){
		return calculationService.account(calculationDto);
	}

	@Data
	public static class CalculationDto{
		private String date;
		private String currency;
		private List<Organization> useDep;
	}
}
