package com.changhong.epc.form.rest.tenant.contract;

import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.changhong.autoform.entity.ProcessBudget;
import com.changhong.epc.bean.form.contract.FormContractPhase;
import com.changhong.epc.constter.form.tenant.contract.FormContractPhaseUrlConst;
import com.changhong.epc.form.execute.impl.ExecuteImpl;
import com.changhong.epc.form.mapper.tenant.FormDataMapper;
import com.changhong.epc.form.service.budget.department.impl.ExpendUseBudgtFun;
import com.changhong.epc.form.service.budget.department.util.ContractStage;
import com.changhong.epc.form.service.tenant.contract.FormContractPhaseService;

/**
 * 合同明细控制层
 * @author liush
 *
 */
@RestController
@RequestMapping(method=RequestMethod.POST)
public class FormContractPhaseRest implements FormContractPhaseUrlConst {
	
	@Resource
	private FormContractPhaseService formContractPhaseService;
	
	/**
	 * 查询所有合同阶段信息
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACTPHASE_LIST_SELECTALL)
	public List<FormContractPhase> selectAll() {
		return formContractPhaseService.selectAll();
	}
	
	/**
	 * 查询单条合同阶段信息
	 * @param formContractPhase
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACTPHASE_BEAN_SELECTONE)
	public FormContractPhase selectOne(@RequestBody FormContractPhase formContractPhase) {
		return formContractPhaseService.selectOne(formContractPhase);
	}
	
	/**
	 * 查询合同阶段信息条数
	 * @param formContractPhase
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACTPHASE_NORMAL_SELECTCOUNT)
	public Integer selectCount(@RequestBody FormContractPhase formContractPhase) {
		return formContractPhaseService.selectCount(formContractPhase);
	}
	
	/**
	 * 查询合同阶段信息
	 * @param formContractPhase
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACTPHASE_LIST_SELECT)
	public List<FormContractPhase> select(@RequestBody FormContractPhase formContractPhase) {
		return formContractPhaseService.select(formContractPhase);
	}
	
	/**
	 * 插入合同阶段信息
	 * @param formContractPhase
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACTPHASE_NORMALTYPE_INSERT)
	public Integer insert(@RequestBody FormContractPhase formContractPhase) {
		return formContractPhaseService.insert(formContractPhase);
	}
	
//	/**
//	 * 更新合同信息
//	 * @param formContractPhase
//	 * @return
//	 */
//	@PostMapping(REST_FORMCONTRACTPHASE_NORMALTYPE_UPDATEBYPRIMARYKEY)
//	public Integer updateByPrimaryKey(@RequestBody FormContractPhase formContractPhase) {
//		return formContractPhaseService.updateByPrimaryKey(formContractPhase);
//	}
	@Resource
	private ExecuteImpl ex;
	
	/**
	 * 合同报销单占用预算
	 */
	@PostMapping(REST_FORMCONTRACTPHASE_NORMALTYPE_BUDGET)
	public boolean contractBud(@RequestBody ProcessBudget processBudget) {
		// System.out.println();
		return ex.executeProcessBudget(processBudget);
	}
	
	
}
