package com.changhong.epc.form.rest.tenant.contract;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.changhong.epc.bean.form.contract.FormContract;
import com.changhong.epc.bean.form.contract.FormContractExtend;
import com.changhong.epc.bean.form.contract.FormContractPhase;
import com.changhong.epc.constter.form.tenant.contract.FormContractUrlConst;
import com.changhong.epc.form.service.tenant.contract.FormContractService;

/**
 * 合同控制层
 * @author liush
 *
 */
@RestController
@RequestMapping(method=RequestMethod.POST)
public class FormContractRest implements FormContractUrlConst {
	
	@Resource
	private FormContractService formContractService;
	
	/**
	 * 按倒序查询所有合同
	 * @param formContract
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_LIST_SELECTALLCONTRACT)
	public List<FormContract> selectAllContract(@RequestBody FormContract formContract) {
		return formContractService.selectAllContract(formContract);
	}
	
	/**
	 * 查询所有合同
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_LIST_SELECTALL)
	public List<FormContract> selectAll() {
		return formContractService.selectAll();
	}
	
	/**
	 * 查询单条合同
	 * @param formContract
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_BEAN_SELECTONE)
	public FormContract selectOne(@RequestBody FormContract formContract) {
		return formContractService.selectOne(formContract);
	}
	
	/**
	 * 分页查询合同
	 * @param formContract
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_LIST_SELECTPAGE)
	public List<FormContract> selectPage(@RequestBody FormContract formContract) {
		return formContractService.selectPage(formContract);
	}
	
	/**
	 * 查询合同条数
	 * @param formContract
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_NORMALTYPE_SELECTCOUNT)
	public Integer selectCount(@RequestBody FormContract formContract) {
		return formContractService.selectCount(formContract);
	}
	
	/**
	 * 
	 * 插入合同
	 * @param formContract
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_NORMALTYPE_INSERT)
	public Integer insert(@RequestBody FormContract formContract) {
		return formContractService.insert(formContract);
	}
	
	/**
	 * 更新合同（依据主键）
	 * @param formContract
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_NORMALTYPE_UPDATEBYPRIMARYKEY)
	public Integer updateByPrimaryKey(@RequestBody FormContract formContract) {
		return formContractService.updateByPrimaryKey(formContract);
	}
	
	/**
	 * 删除合同
	 * @param formContract
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_NORMALTYPE_DELETE)
	public Integer delete(@RequestBody FormContract formContract) {
		return formContractService.delete(formContract);
	}
	
	/**
	 * 插入合同信息（取得返回连接id）
	 * @param formContract
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_NORMALTYPE_FORMCONTRACTSAVE)
	public Integer formContractSave(@RequestBody FormContractExtend formContractExtend) {
		formContractService.formContractSave(formContractExtend);
		return formContractExtend.getId();
	}
	
	/**
	 * 插入合同及其阶段信息
	 * @param formContract
	 * @return
	 */
	@PostMapping(REST_FORMCONTRACT_NORMALTYPE_SAVE)
	public Integer save(@RequestBody FormContractExtend formContractExtend) {
		return formContractService.save(formContractExtend);
	}
	
}
