package com.changhong.epc.form.service.budget;

import java.util.List;
import java.util.Map;

import org.springframework.web.bind.annotation.RequestBody;

import com.changhong.autoform.entity.BudgetData;
import com.changhong.autoform.entity.BudgetTitle;
import com.changhong.autoform.entity.ProcessBudget;
import com.changhong.epc.constter.system.businesscode.BudgetBusinessMeaningCode;
import com.changhong.epc.form.service.budget.department.model.BudgetExtend;

/**
 * 预算处理  （查询  回写）
 * 		 ........
 * @author wangZX
 *
 */
public interface IBudgetMoney extends BudgetBusinessMeaningCode{

	/**
	 * 查询预算列表
	 * @param budgetData
	 * @return
	 */
	public Map<String,Object>  selectBudgetList(BudgetData budgetData);
	
	/**
	 * 回写预算
	 * @param processBudget
	 * @return
	 */
	//public Object writeBudget(ProcessBudget processBudget);
	
	public Boolean executeProcessRefunds(ProcessBudget processBudget);
	
	/**
	 * 扩展预算单时间
	 * @param budgetExtend
	 * @return
	 */
	public boolean extendTime(BudgetExtend budgetExtend);
	
	/**
	 * 扩展预算单金额
	 * @param budgetExtend
	 * @return
	 */
	public boolean extendMoney(BudgetExtend budgetExtend);
	
	/**
	 * 追加预算
	 * @param budgetExtend
	 * @return
	 */
	public int addMoney(ProcessBudget processBudget);
	
	/**
	 * 还款
	 * @param budgetExtend
	 * @return
	 */
	public boolean repaymentMoney(BudgetExtend budgetExtend);
	
	/**
	 * 获取标题
	 * @param key
	 * @return
	 */
	public List<BudgetTitle> getTitles(String key);
	
	/**
	 * 回收预算
	 * @param budgetExtend
	 * @return
	 */
	public boolean recycleMoney(BudgetExtend budgetExtend);
	
	/**
	 * 选择 回写预算方式
	 * @param processBudget
	 */
	public Boolean selectorModel(ProcessBudget processBudget);
}	
