package com.changhong.epc.form.service.budget.department;

import java.util.List;

import com.changhong.epc.bean.tenant.system.DepartmentRelation;
import com.changhong.epc.rely.api.bean.Organization;

/**
 * 部门关系业务层
 * @author liush
 *
 */
public interface DepartmentRelationService {
	
	/**
	 * 获取传入上下级部门code判断其上级是否正确
	 * @param departmentRelation
	 * @return
	 */
	boolean judgeSuperior(DepartmentRelation departmentRelation);

	/**
	 * 获取传入上下级部门code判断其上级是否正确
	 * @param code
	 * @param parentCode
	 * @return
	 */
	boolean judgeSuperior(String code, String parentCode);
	
	/**
	 * 依据部门code获取上级部门code集合
	 * @param code
	 * @return
	 */
	List<String> getSuperiorDepartment(String code);
	
	/**
	 * 依据部门code获取上级部门code
	 * @param code
	 * @return
	 */
	String getSuperiorDepartmentCode(String code);

	/**
	 * 依据部门code获取下级部门code集合
	 * @param parentCode
	 * @return
	 */
	List<String> getSubordinateDepartment(String parentCode);
	
	/**
	 * 获得上级部门组织机构
	 */
	DepartmentRelation selectHigCode(DepartmentRelation code);
	
	/**
	 * 查询所有一级部门
	 */
	public List<Organization> getHigCode(String code);
	
	/**
	 * 查询所有一级部门
	 */
	public List<Organization> getOne(String companyId);
	

}
