package com.changhong.epc.form.service.budget.department.impl;

import com.alibaba.fastjson.annotation.JSONField;
import com.changhong.autoform.entity.ProcessBudget;
import com.changhong.epc.bean.form.FormType;
import com.changhong.epc.bean.form.budget.BudgetUserDefined;
import com.changhong.epc.bean.form.budget.BudgetUserDefined.Dimension;
import com.changhong.epc.bean.form.budget.filtrate.BudgetclassifyKey;
import com.changhong.epc.bean.form.budget.filtrate.BudgetclassifyValue;
import com.changhong.epc.bean.tenant.cost.budgetlog.MoneyApplyLog;
import com.changhong.epc.bean.tenant.system.SystemConfig;
import com.changhong.epc.constter.base.BaseConst;
import com.changhong.epc.constter.system.run.EpcRestInterface;
import com.changhong.epc.form.execute.IFormOthersOperation;
import com.changhong.epc.form.service.budget.department.SuperBudgt;
import com.changhong.epc.form.service.budget.department.model.BudgetRow;
import com.changhong.epc.form.service.budget.department.model.BudgetRowUpdateRecord;
import com.changhong.epc.form.service.budget.impl.GetConstant;
import com.changhong.epc.rely.api.epc.tenant.SystemConfigApi;
import com.iemsoft.framework.cloud.core.base.ResMsg;
import com.iemsoft.framework.cloud.core.exception.IEMRestException;
import com.iemsoft.framework.cloud.core.tools.JSONTool;
import com.iemsoft.framework.cloud.core.tools.SpringUtil;
import com.iemsoft.framework.cloud.core.tools.StringUtil;
import com.iemsoft.framework.cloud.ribbon.RestInterface;
import lombok.extern.slf4j.Slf4j;

import java.math.BigDecimal;
import java.util.*;

@Slf4j
public class ApplyUseBudgtFun extends SuperBudgt implements BaseConst{
	
	//@Resource
	private IFormOthersOperation formOthersOperation = SpringUtil.getBean(IFormOthersOperation.class);
	
	@Override
	@JSONField(serialize=false)
	public List<Map<String,Object>>  getUsableBudgetList() {
		
		List<Map<String,Object>> datas = new ArrayList<>();
 		Collection<BudgetclassifyValue> values = data.values();
 		
 		// *
		values.forEach(o->datas.addAll(o.dispose()));
		return datas;
	}

	private MoneyApplyLog moneyApplyLog = new MoneyApplyLog();
	@Override
	public boolean executeWriteBack(Map<String, Object> fromInfo, ProcessBudget processBudget,String formID) {
		log.debug("ApplyUseBudgtFun.executeWriteBack > frominfo: "+JSONTool.toJson(fromInfo));
		log.debug("测试参数3："+JSONTool.toJson(fromInfo));
		log.debug("测试参数4"+JSONTool.toJson(processBudget));
		log.debug("测试参数5"+JSONTool.toJson(formID));
		
		
		processBudget.setAlias(BUDGET_SUB_FROM);
		String qFormId = GetConstant.getFormIdGetConstant(YS_FORMID);
		processBudget.setFormId(qFormId);
		if(fromInfo.get(TO_WRITE_BUDGET).toString().contains(",")){//871
			return false;
		}
		//记录log参数
		this.moneyApplyLog.setAlterAlias(BUDGET_ITEM_BALANCE);
		this.moneyApplyLog.setFormId(processBudget.getFormId());
		this.moneyApplyLog.setQFormId(qFormId);
		this.moneyApplyLog.setQRowId(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));//871
		this.moneyApplyLog.setRowId(processBudget.getDataRowNUm());
		this.moneyApplyLog.setAlterAlias(BUDGET_ITEM_MONEY);
		this.moneyApplyLog.setOperatorMsg("申请使用预算--存主表单dataRowNum");
		this.moneyApplyLog.initParam();
		
		budgetItemBalanceType = Integer.parseInt(fromInfo.get(BUDGETITEMBALANCETYPE).toString());//0
		processBudget.setDataRowNUm(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));//871
		Map<String,Object> subData =  formOthersOperation.getFromInfo(processBudget);//
		log.debug("测试参数6"+JSONTool.toJson(subData));
		BudgetRow budgetRow =  new BudgetRow();
		budgetRow.setTenantId(processBudget.getTenantID());//13
		budgetRow.setDataRowNumber(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));//871
		budgetRow.setBalance(subData.get(BUDGET_ITEM_BALANCE).toString());//6000
		budgetRow.setMoney(money(fromInfo));//20
		verify(budgetRow).forEach(o->{
			formOthersOperation.updateFormFieldProperty(o.getProcessBudget(), o.getData() ,o.getFormType(),o.getIBillCostLog());
		});
		
		return true;
	}
	
	private static String money(Map<String,Object> map){
		Object ysm = map.get(BUDGET_ITEM_MONEY);
		if(ysm != null)
			return Objects.toString(ysm,"0");
		ysm = map.get(APPLY_USE_MONEY);
		if(ysm != null)
			return Objects.toString(ysm,"0");
		ysm = map.get(EXPEND_USE_MONEY);
		if(ysm != null)
			return Objects.toString(ysm,"0");
		return "0";
	}
	
	/**
	 * 扣除费用
	 * @param budgetRow
	 * @return
	 */
	public List<BudgetRowUpdateRecord> verify(BudgetRow budgetRow){
		List<BudgetRowUpdateRecord> budgetRowRecord = new ArrayList<>();
		BigDecimal applyMoney = new BigDecimal(budgetRow.getMoney());//20
		BigDecimal balance =new BigDecimal(budgetRow.getBalance());//6000
		BigDecimal money  =  balance.subtract(applyMoney);
		
		log.debug("上级预算" + balance);
		log.debug("当前预算" + applyMoney);
		log.debug("计算后" + money);
		
		this.moneyApplyLog.setAlterContentOld(balance.toEngineeringString());
		this.moneyApplyLog.setAlterContentNew(money.toEngineeringString());
		
		if(money.compareTo(BigDecimal.ZERO) == -1){
			throw new IEMRestException("预算不足");
		}
		
		BudgetRowUpdateRecord param = new BudgetRowUpdateRecord(
				new ProcessBudget(GetConstant.getFormIdGetConstant(YS_FORMID)
						, budgetRow.getDataRowNumber(), BUDGET_SUB_FROM)
				, BUDGET_ITEM_BALANCE, getValueByBalanceType(money) + "",budgetRow.getTenantId());
		
		param.setFormType(FormType.SQ);
		param.setIBillCostLog(this.moneyApplyLog);
		budgetRowRecord.add(param);
		return budgetRowRecord;
	}

	/**
	 * 退回费用
	 * @param budgetRow
	 * @return
	 */
	private List<BudgetRowUpdateRecord> refunds(BudgetRow budgetRow){
		List<BudgetRowUpdateRecord> budgetRowRecord = new ArrayList<>();
		BigDecimal applyMoney = new BigDecimal(budgetRow.getMoney());
		BigDecimal balance =new BigDecimal(budgetRow.getBalance());
		BigDecimal money = balance.add(applyMoney);
		budgetRowRecord.add(new BudgetRowUpdateRecord(
				new ProcessBudget(GetConstant.getFormIdGetConstant(YS_FORMID)
						, budgetRow.getDataRowNumber(), BUDGET_SUB_FROM)
				, BUDGET_ITEM_BALANCE, getValueByBalanceType(money) + "","13"));
		return budgetRowRecord;
	}

	@Override
	public void setDataSource(BudgetUserDefined budgetUserDefined,
			Map<BudgetclassifyKey,BudgetclassifyValue> data) {
		this.budgetUserDefined = budgetUserDefined;
		this.data = data;
	}
	
	@Override
	public boolean isMereg() {
		return false;
	}
	@Override
	public boolean isFilter(Map<String, Object> data) {
		return true;
	}

	@Override
	public BudgetUserDefined getBudgetUserDefined() {
		//条件维度修改从配置表里面查询出来的
		return this.getDimension();
//		BudgetUserDefined budgetUserDefined = new BudgetUserDefined();
//		budgetUserDefined.setFilterSubForm(false);
//		budgetUserDefined.setMergeSubForm(false);
//		budgetUserDefined.setKey("ApplyUseBudgtFun");
//		budgetUserDefined.setVal("申请使用预算");
//		List<Dimension> mainDimension = new ArrayList<>();
//		List<Dimension> subDimension = new ArrayList<>();
//		
//		mainDimension.add(new Dimension(BUDGET_START_DATE, true));
//		mainDimension.add(new Dimension(CURRENCY, true));
//		
//		mainDimension.add(new Dimension(APPLY_COST_TYPE));
//		mainDimension.add(new Dimension(APPLY_DEPARTMENT, BUDGET_ITEM_DEPARTMENT));
//		
//		budgetUserDefined.setMainDimension(mainDimension);
//		budgetUserDefined.setSubDimension(subDimension);
//		
//		return budgetUserDefined;
	}
	
	@Override
	public Boolean excuteRefunds(Map<String, Object> formInfo) {
		budgetItemBalanceType = Integer.parseInt(StringUtil.toString(formInfo.get(BUDGETITEMBALANCETYPE)));
		if(formInfo.get(TO_WRITE_BUDGET).toString().contains(",")){
			return false;
		}
		/**查出预算单信息*/
		superFormId = formInfo.get(YS_FORMID).toString();
		ProcessBudget processBudget = new ProcessBudget();
		processBudget.setAlias(BUDGET_SUB_FROM);
		processBudget.setFormId(superFormId);
		processBudget.setDataRowNUm(Integer.parseInt(formInfo.get(TO_WRITE_BUDGET).toString()));
		Map<String,Object> subData = formOthersOperation.getFromInfo(processBudget);
		if(subData.isEmpty())
			return false;
		
		/**为退回准备参数*/
		BudgetRow budgetRow =  new BudgetRow();
		budgetRow.setDataRowNumber(Integer.parseInt(formInfo.get(TO_WRITE_BUDGET).toString()));
		budgetRow.setBalance(subData.get(BUDGET_ITEM_BALANCE).toString());
		budgetRow.setMoney(money(formInfo));
		refunds(budgetRow).stream().forEach( o ->{
			formOthersOperation.updateFormFieldProperty(o.getProcessBudget(), o.getData() ,o.getFormType(),o.getIBillCostLog());
		});
		return true;
	}
	//访问费用云，取出维度
	public Object getData(String url,Map<String,Object> map){
		RestInterface restInterface = SpringUtil.getBean(SERVER_TENANT.getBeanName(), RestInterface.class);
		Object data = restInterface.post(url, map, ResMsg.class, EpcRestInterface.getEpcHeads()).getData();
		// System.out.println("---------------返回结果--------");
		// System.out.println("---------------返回结果--------");
		// System.out.println("---------------返回结果--------");
		// System.out.println(JSONTool.toJson(data));
		return data!=null?data:null;
	}
	
	public BudgetUserDefined getDimension(){
		//维度配置
		List<SystemConfig> config = SpringUtil.getBean(SystemConfigApi.class)
				.getSystemConfigs(SystemConfig.of(BUDGET_CONFIGURATION, "1"));
		// System.out.println("维度配置表:"+JSONTool.toJson(config));
		BudgetUserDefined budgetUserDefined = new BudgetUserDefined();
		budgetUserDefined.setFilterSubForm(false);
		budgetUserDefined.setMergeSubForm(false);
		budgetUserDefined.setKey(APPLY_USR_BUDGTFUN);
		budgetUserDefined.setVal("申请使用预算");
		List<Dimension> mainDimension = new ArrayList<>();
		List<Dimension> subDimension = new ArrayList<>();
		for(SystemConfig c: config){
			if(CURRENCY.equals(c.getCkey())){
				mainDimension.add(new Dimension(c.getCkey(), true));
			}else if(APPLY_DEPARTMENT.equals(c.getCkey()) || BUDGET_ITEM_DEPARTMENT.equals(c.getCkey())){
				Dimension d = new Dimension(APPLY_DEPARTMENT, BUDGET_ITEM_DEPARTMENT);
				d.setIsRemove(true);
				mainDimension.add(d);
			}else if(BUDGET_START_DATE.equals(c.getCkey()) || BUDGET_END_DATE.equals(c.getCkey())) {
				Dimension d = new Dimension(APPLY_DATE, c.getCkey());
				d.setIsRemove(true);
				mainDimension.add(d);
			}else{
				mainDimension.add(new Dimension(c.getCkey()));
			}
		}
		budgetUserDefined.setMainDimension(mainDimension);
		budgetUserDefined.setSubDimension(subDimension);
		// System.out.println("匹配后维度条件:"+JSONTool.toJson(budgetUserDefined));
		return budgetUserDefined;
	}
	
	public BudgetUserDefined getDimension(String fun){
		List<SystemConfig> config = SpringUtil.getBean(SystemConfigApi.class)
				.getSystemConfigs(SystemConfig.of(fun, "1"));
		// System.out.println("维度配置表:"+JSONTool.toJson(config));
		BudgetUserDefined budgetUserDefined = new BudgetUserDefined();
		budgetUserDefined.setFilterSubForm(false);
		budgetUserDefined.setMergeSubForm(false);
		budgetUserDefined.setKey(APPLY_USR_BUDGTFUN);
		budgetUserDefined.setVal("申请使用预算");
		List<Dimension> mainDimension = new ArrayList<>();
		List<Dimension> subDimension = new ArrayList<>();
		for(SystemConfig c: config){
			if(CURRENCY.equals(c.getCkey())){
				mainDimension.add(new Dimension(c.getCkey(), true));
			}else if(APPLY_DEPARTMENT.equals(c.getCkey()) || BUDGET_ITEM_DEPARTMENT.equals(c.getCkey())){
				Dimension d = new Dimension(APPLY_DEPARTMENT, BUDGET_ITEM_DEPARTMENT);
				d.setIsRemove(true);
				mainDimension.add(d);	
			}else if(BUDGET_START_DATE.equals(c.getCkey()) || BUDGET_END_DATE.equals(c.getCkey())) {
				Dimension d = new Dimension(APPLY_DATE, c.getCkey());
				d.setIsRemove(true);
				mainDimension.add(d);
			}else{
				mainDimension.add(new Dimension(c.getCkey()));
			}
		
		}
		budgetUserDefined.setMainDimension(mainDimension);
		budgetUserDefined.setSubDimension(subDimension);
		// System.out.println("匹配后维度条件:"+JSONTool.toJson(budgetUserDefined));
		return budgetUserDefined;
	}
	
	public BudgetUserDefined getBudgetUserDefined(String fun) {
		//条件维度修改从配置表里面查询出来的
		return this.getDimension(fun);
	}
	
}
