package com.changhong.epc.form.service.budget.department.impl;

import com.alibaba.fastjson.annotation.JSONField;
import com.changhong.autoform.entity.ProcessBudget;
import com.changhong.epc.bean.form.FormType;
import com.changhong.epc.bean.form.budget.BudgetUserDefined;
import com.changhong.epc.bean.form.budget.BudgetUserDefined.Dimension;
import com.changhong.epc.bean.form.budget.filtrate.BudgetclassifyKey;
import com.changhong.epc.bean.form.budget.filtrate.BudgetclassifyValue;
import com.changhong.epc.bean.tenant.cost.budgetlog.MoneyExpendLog;
import com.changhong.epc.bean.tenant.system.SystemConfig;
import com.changhong.epc.constter.base.BaseConst;
import com.changhong.epc.constter.system.run.EpcRestInterface;
import com.changhong.epc.form.execute.IFormOthersOperation;
import com.changhong.epc.form.mapper.tenant.FormDataMapper;
import com.changhong.epc.form.service.budget.department.SuperBudgt;
import com.changhong.epc.form.service.budget.department.model.BudgetRow;
import com.changhong.epc.form.service.budget.department.model.BudgetRowUpdateRecord;
import com.changhong.epc.form.service.budget.department.util.ContractStage;
import com.changhong.epc.form.service.budget.impl.GetConstant;
import com.changhong.epc.rely.api.epc.tenant.SystemConfigApi;
import com.iemsoft.framework.cloud.core.base.ResMsg;
import com.iemsoft.framework.cloud.core.exception.IEMRestException;
import com.iemsoft.framework.cloud.core.tools.JSONTool;
import com.iemsoft.framework.cloud.core.tools.SpringUtil;
import com.iemsoft.framework.cloud.core.tools.StringUtil;
import com.iemsoft.framework.cloud.ribbon.RestInterface;
import lombok.extern.slf4j.Slf4j;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.*;

/**
 */
@Slf4j
public class ExpendUseBudgtFun extends SuperBudgt implements BaseConst {
	
	/**
	 * 修改子表单你
	 */
	
	private FormDataMapper formMapper = SpringUtil.getBean(FormDataMapper.class);

	
	//@Resource
	private IFormOthersOperation formOthersOperation = SpringUtil.getBean(IFormOthersOperation.class);
	
	@Override
	@JSONField(serialize=false)
	public List<Map<String,Object>>  getUsableBudgetList() {
		
		List<Map<String,Object>> datas = new ArrayList<>();
 		Collection<BudgetclassifyValue> values = data.values();
		values.forEach(o->datas.addAll(o.dispose()));
		return datas;
	}

//	@Override
//	public boolean executeWriteBack(Map<String, Object> fromInfo, ProcessBudget processBudget) {
//		log.debug("ApplyUseBudgtFun.executeWriteBack > frominfo: "+JSONTool.toJson(fromInfo));
//		List<Map<String,Object>> subData = (List<Map<String, Object>>) fromInfo.get(BUDGET_SUB_FROM);
//		List<BudgetRow> budgetRows =  new ArrayList<>();
//		subData.forEach(o->budgetRows.add(new BudgetRow(o)));
//		budgetRows.get(0).setMoney(money(fromInfo));
//		log.debug("ApplyUseBudgtFun.executeWriteBack > budgetRows:" + JSONTool.toJson(budgetRows));
//		verify(budgetRows).forEach(o->{
//			formOthersOperation.updateFormFieldProperty(o.getProcessBudget(), o.getData());
//		});
//		
//		return true;
//	}
	
	private MoneyExpendLog moneyExpendLog = new MoneyExpendLog();
	
	@Transactional
	@Override
	public boolean executeWriteBack(Map<String, Object> fromInfo, ProcessBudget processBudget,String formID) {
		log.debug("ApplyUseBudgtFun.executeWriteBack > frominfo: "+JSONTool.toJson(fromInfo));
		processBudget.setAlias(BUDGET_SUB_FROM);
		//;
		
		String ysFormid = GetConstant.getFormIdGetConstant(YS_FORMID);
		processBudget.setFormId(ysFormid);
		if(fromInfo.get(TO_WRITE_BUDGET).toString().contains(",")){
			return false;
		}
		
		//记录log参数 你能优化就优化了吧..
		this.moneyExpendLog.setAlterAlias(BUDGET_ITEM_BALANCE);
		this.moneyExpendLog.setFormId(processBudget.getFormId());
		this.moneyExpendLog.setQFormId(ysFormid);
		this.moneyExpendLog.setQRowId(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));
		this.moneyExpendLog.setRowId(processBudget.getDataRowNUm());
		this.moneyExpendLog.setAlterAlias(BUDGET_ITEM_MONEY);
		this.moneyExpendLog.setOperatorMsg("报销使用预算--存主表单dataRowNum");
		this.moneyExpendLog.initParam();
		
		budgetItemBalanceType = Integer.parseInt(fromInfo.get("budgetItemBalanceType").toString());
		processBudget.setDataRowNUm(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));
		Map<String,Object> subData =  formOthersOperation.getFromInfo(processBudget);
		// System.out.println("2:"+JSONTool.toJson(subData));
		BudgetRow budgetRow =  new BudgetRow();
		budgetRow.setDataRowNumber(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));
		budgetRow.setBalance(subData.get(BUDGET_ITEM_BALANCE).toString());
		budgetRow.setMoney(money(fromInfo));
		budgetRow.setTenantId(processBudget.getTenantID());
		verify(budgetRow).forEach(o->{
			formOthersOperation.updateFormFieldProperty(o.getProcessBudget(), o.getData() ,o.getFormType(),o.getIBillCostLog());
		});
		if(GetConstant.getFormIdGetConstant(EXPENDCONTRACT).equals(formID)){
			updateContract(fromInfo,formID);
		}
		return true;
	}
	
	
	private static String money(Map<String,Object> map){
		Object ysm = map.get(BUDGET_ITEM_MONEY);
		if(ysm != null)
			return Objects.toString(ysm,"0");
		ysm = map.get(APPLY_USE_MONEY);
		if(ysm != null)
			return Objects.toString(ysm,"0");
		ysm = map.get(EXPEND_USE_MONEY);
		if(ysm != null)
			return Objects.toString(ysm,"0");
		return "0";
	}
	
	
//	public List<BudgetRowUpdateRecord> verify(List<BudgetRow> budgetRows){
//		List<BudgetRowUpdateRecord> budgetRowRecord = new ArrayList<>();
//		for (BudgetRow budgetRow : budgetRows) {
//			Double applyMoney = Double.valueOf(budgetRow.getMoney());
//			for(BudgetRow supperbudgetRow : budgetRow.getSupperBudgetRows()){
//				Double balance = Double.valueOf(supperbudgetRow.getBalance());
//				Double money = balance - applyMoney;
//				if(money < 0){
//					applyMoney -= balance;
//					budgetRowRecord.add(new BudgetRowUpdateRecord(
//							new ProcessBudget(GetConstant.getFormIdGetConstant(YS_FORMID)
//									, supperbudgetRow.getDataRowNumber(), BUDGET_SUB_FROM)
//							, BUDGET_ITEM_BALANCE, "0"));
//				}else{
//					budgetRowRecord.add(new BudgetRowUpdateRecord(
//							new ProcessBudget(GetConstant.getFormIdGetConstant(YS_FORMID)
//									, supperbudgetRow.getDataRowNumber(), BUDGET_SUB_FROM)
//							, BUDGET_ITEM_BALANCE, money+""));
//					applyMoney = 0D;
//				}
//			}
//			if(applyMoney < 0){
//				throw new IEMRestException("预算不足");
//			}
//			
//		}
//		return budgetRowRecord;
//	}

	public List<BudgetRowUpdateRecord> verify(BudgetRow budgetRow){
		List<BudgetRowUpdateRecord> budgetRowRecord = new ArrayList<>();
		BigDecimal applyMoney = new BigDecimal(budgetRow.getMoney());
		BigDecimal balance =new BigDecimal(budgetRow.getBalance());
		BigDecimal money  =  balance.subtract(applyMoney);
		if(money.compareTo(BigDecimal.ZERO) == -1){
			throw new IEMRestException("预算不足");
		}
		

		BudgetRowUpdateRecord param = new BudgetRowUpdateRecord(
				new ProcessBudget(GetConstant.getFormIdGetConstant(YS_FORMID)
						, budgetRow.getDataRowNumber(), BUDGET_SUB_FROM)
				, BUDGET_ITEM_BALANCE, getValueByBalanceType(money) + ""
				,budgetRow.getTenantId());
		
		param.setFormType(FormType.BX);
		param.setIBillCostLog(this.moneyExpendLog);
		
		budgetRowRecord.add(param);
		return budgetRowRecord;
	}
	@Override
	public void setDataSource(BudgetUserDefined budgetUserDefined,
			Map<BudgetclassifyKey,BudgetclassifyValue> data) {
		this.budgetUserDefined = budgetUserDefined;
		this.data = data;
	}
	
	@Override
	public boolean isMereg() {
		return false;
	}
	@Override
	public boolean isFilter(Map<String, Object> data) {
		return true;
	}

	@Override
	public BudgetUserDefined getBudgetUserDefined() {
		//条件维度从写死，变成从维度表里面取出
		return this.getDimension();
//		BudgetUserDefined budgetUserDefined = new BudgetUserDefined();
//		budgetUserDefined.setFilterSubForm(false);
//		budgetUserDefined.setMergeSubForm(false);
//		budgetUserDefined.setKey("ExpendUseBudgtFun");
//		budgetUserDefined.setVal("报销使用预算");
//		List<Dimension> mainDimension = new ArrayList<>();
//		List<Dimension> subDimension = new ArrayList<>();
//		
//		mainDimension.add(new Dimension(BUDGET_START_DATE, true));
//		mainDimension.add(new Dimension(CURRENCY, true));
//		mainDimension.add(new Dimension(BUDGET_PROJECT));
//
//		mainDimension.add(new Dimension(EXPEND_COST_TYPE));
//		mainDimension.add(new Dimension(EXPEND_DEPARTMENT, BUDGET_ITEM_DEPARTMENT));
//		
//		budgetUserDefined.setMainDimension(mainDimension);
//		budgetUserDefined.setSubDimension(subDimension);
//		
//		return budgetUserDefined;
	}
	
	/**
	 * 修改合同报销阶段
	 */
	public boolean updateContract(Map<String, Object> fromInfo,String formID){
		
		String tenantID = Objects.toString(fromInfo.get("TENANTID"),"");
		
		//去出付款阶段表名
		String formId = GetConstant.getFormIdGetConstant(CONTRACT);
		String name = getTableName(formId,tenantID,BUDGET_SUB_FROM);
		//合同报销单子表单
		List<ContractStage> son1 = getSonForm(formID,
					Objects.toString(fromInfo.get(DATAROWNUMBER),"0"),tenantID);
		
		//合同付款阶段子表单
		List<ContractStage> son2 = getSonForm(name,
					Objects.toString(fromInfo.get("selectContracts"),"0"));
		//将报销单中金额添加到付款阶段
		for(ContractStage map : son1){
			for(ContractStage map1 : son2){
				if(map.getPaymentStage().equals(map1.getPaymentStage())){
					map1.setAlreadyPaid(map.getFukuanjine()+map1.getAlreadyPaid());
					if(map1.getAlreadyPaid()>map1.getPaymentMoney()){
						throw new IEMRestException("支付金额超出");
					}else{
						formMapper.updateContract(map1, name);
					}
				}
			}
		}
		return true;
	}
	
	
	/**
	 * 查询当前子表单
	 */
	public List<ContractStage> getSonForm(String formID,String dataRowNum,String tenantID){
		String name = getTableName(formID,tenantID,SUBFORM);
		List<ContractStage> map = formMapper.selectSonForm(name, Integer.parseInt(dataRowNum));
		return map;
	} 
	
	/**
	 * 拼接表名
	 */
	public String getTableName(String formID,String tenantID,String subForm){
		return "formdata_"+tenantID+"_"+formID+"_"+subForm;
	}
	
	/**
	 * 取出付款阶段子表单
	 */
	public List<ContractStage> getSonForm(String name,String dataRowNum){
		List<ContractStage> map = formMapper.selectSonsForm(name, Integer.parseInt(dataRowNum));
		return map;
	}
	
	/**
	 * Object转换Double
	 */
	public Double toInt(Object o){
		return Double.parseDouble(Objects.toString(o, "0"));
	}

	/**
	 * 执行扣款
	 */
	@Override
	public Boolean excuteRefunds(Map<String, Object> formInfo) {
		budgetItemBalanceType = Integer.parseInt(StringUtil.toString(formInfo.get(BUDGETITEMBALANCETYPE)));
		if(formInfo.get(TO_WRITE_BUDGET).toString().contains(",")){
			return false;
		}
		/**查出预算单信息*/
		superFormId = formInfo.get(YS_FORMID).toString();
		ProcessBudget processBudget = new ProcessBudget();
		processBudget.setAlias(BUDGET_SUB_FROM);
		processBudget.setFormId(superFormId);
		processBudget.setDataRowNUm(Integer.parseInt(formInfo.get(TO_WRITE_BUDGET).toString()));
		Map<String,Object> subData = formOthersOperation.getFromInfo(processBudget);
		if(subData.isEmpty())
			return false;
		
		/**为退回准备参数*/
		BudgetRow budgetRow =  new BudgetRow();
		budgetRow.setDataRowNumber(Integer.parseInt(formInfo.get(TO_WRITE_BUDGET).toString()));
		budgetRow.setBalance(subData.get(BUDGET_ITEM_BALANCE).toString());
		budgetRow.setMoney(money(formInfo));
		refunds(budgetRow).stream().forEach( o ->{
			formOthersOperation.updateFormFieldProperty(o.getProcessBudget(), o.getData() ,o.getFormType(),o.getIBillCostLog());
		});
		return true;
	}
	/**
	 * 扣款参数
	 * @param budgetRow
	 * @return
	 */
	private List<BudgetRowUpdateRecord> refunds(BudgetRow budgetRow){
		List<BudgetRowUpdateRecord> budgetRowRecord = new ArrayList<>();
		BigDecimal applyMoney = new BigDecimal(budgetRow.getMoney());
		BigDecimal balance =new BigDecimal(budgetRow.getBalance());
		BigDecimal money = balance.add(applyMoney);
		
		budgetRowRecord.add(new BudgetRowUpdateRecord(
				new ProcessBudget(GetConstant.getFormIdGetConstant(YS_FORMID)
						, budgetRow.getDataRowNumber(), BUDGET_SUB_FROM)
				, BUDGET_ITEM_BALANCE, getValueByBalanceType(money) + ""
				,budgetRow.getTenantId()));
		return budgetRowRecord;
	}
	public BudgetUserDefined getDimension(){
		List<SystemConfig> config = SpringUtil.getBean(SystemConfigApi.class)
				.getSystemConfigs(SystemConfig.of(BUDGET_PROJECT_CONFIGURATION, "1"));
		// System.out.println("维度配置表:"+JSONTool.toJson(config));
		BudgetUserDefined budgetUserDefined = new BudgetUserDefined();
		budgetUserDefined.setFilterSubForm(false);
		budgetUserDefined.setMergeSubForm(false);
		budgetUserDefined.setKey("ExpendUseBudgtFun");
		budgetUserDefined.setVal("报销使用预算");
		List<Dimension> mainDimension = new ArrayList<>();
		List<Dimension> subDimension = new ArrayList<>();
		for(SystemConfig c: config){
			if(BUDGET_START_DATE.equals(c.getCkey()) || CURRENCY.equals(c.getCkey())){
				mainDimension.add(new Dimension(c.getCkey(), true));
			}else if(EXPEND_DEPARTMENT.equals(c.getCkey()) || BUDGET_ITEM_DEPARTMENT.equals(c.getCkey())){
				Dimension d = new Dimension(EXPEND_DEPARTMENT, BUDGET_ITEM_DEPARTMENT);
				d.setIsRemove(true);
				mainDimension.add(d);	
			}else{
				mainDimension.add(new Dimension(c.getCkey()));
			}
		
		}
		budgetUserDefined.setMainDimension(mainDimension);
		budgetUserDefined.setSubDimension(subDimension);
		// System.out.println("匹配后维度条件:"+JSONTool.toJson(budgetUserDefined));
		return budgetUserDefined;
	}
	//访问费用云，取出预算维度配置
	public Object getData(String url,Map<String,Object> map){
		RestInterface restInterface = SpringUtil.getBean(SERVER_TENANT.getBeanName(), RestInterface.class);
		Object data = restInterface.post(url, map, ResMsg.class, EpcRestInterface.getEpcHeads()).getData();
		// System.out.println("---------------返回结果--------");
		// System.out.println("---------------返回结果--------");
		// System.out.println("---------------返回结果--------");
		// System.out.println(JSONTool.toJson(data));
		return data!=null?data:null;
	}
	
	public BudgetUserDefined getDimension(String fun){
		List<SystemConfig> config = SpringUtil.getBean(SystemConfigApi.class)
				.getSystemConfigs(SystemConfig.of(fun, "1"));
		// System.out.println("维度配置表:"+JSONTool.toJson(config));
		BudgetUserDefined budgetUserDefined = new BudgetUserDefined();
		budgetUserDefined.setFilterSubForm(false);
		budgetUserDefined.setMergeSubForm(false);
		budgetUserDefined.setKey("ExpendUseBudgtFun");
		budgetUserDefined.setVal("报销使用预算");
		List<Dimension> mainDimension = new ArrayList<>();
		List<Dimension> subDimension = new ArrayList<>();
		for(SystemConfig c: config){
			if(CURRENCY.equals(c.getCkey())){
				mainDimension.add(new Dimension(c.getCkey(), true));
			}else if(EXPEND_DEPARTMENT.equals(c.getCkey()) || BUDGET_ITEM_DEPARTMENT.equals(c.getCkey())){
				Dimension d = new Dimension(EXPEND_DEPARTMENT, BUDGET_ITEM_DEPARTMENT);
				d.setIsRemove(true);
				mainDimension.add(d);	
			}else if(BUDGET_START_DATE.equals(c.getCkey())) {
				Dimension d = new Dimension(BUDGET_START_DATE_ONE, BUDGET_START_DATE);
				d.setIsRemove(true);
				mainDimension.add(d);
			}else{
				mainDimension.add(new Dimension(c.getCkey()));
			}
		
		}
		budgetUserDefined.setMainDimension(mainDimension);
		budgetUserDefined.setSubDimension(subDimension);
		// System.out.println("匹配后维度条件:"+JSONTool.toJson(budgetUserDefined));
		return budgetUserDefined;
	}
	
	public BudgetUserDefined getBudgetUserDefined(String fun) {
		//条件维度从写死，变成从维度表里面取出
		return this.getDimension(fun);
	}
}
