package com.changhong.epc.form.service.budget.tool;

import com.changhong.epc.bean.form.FormType;
import com.changhong.epc.bean.tenant.cost.CostFromMapping;
import com.changhong.epc.bean.tenant.system.SystemConfig;
import com.changhong.epc.constter.form.budget.BudgetMsg;
import com.changhong.epc.form.service.budget.tool.entity.UpdateBudgetEntity;

import java.util.List;

/**
 * 预算变更(使用|占用)
 */
public interface IUpdateBudget extends BudgetMsg {

    /**
     * 验证预算是否可以被(使用|占用)
     * @param updateBudgetEntity
     */
    void checkBudget(UpdateBudgetEntity updateBudgetEntity);

    /**
     * 开始(使用|占用)预算
     * @param updateBudgetEntity
     */
    void updateBudget(UpdateBudgetEntity updateBudgetEntity);

    /**
     * 流程执行结束后回调
     * @param updateBudgetEntity
     */
    void flowAfterCall(UpdateBudgetEntity updateBudgetEntity);

    /**
     * @Author WangYX
     * @Description 回滚扣减预算
     * @Date 2019/3/14 4:02 PM
     */
    void rollback(UpdateBudgetEntity updateBudgetEntity);

    /**
     * 添加表单依赖其他表单信息
     * @param costFromMappings
     */
    void setCostFromMappings(List<CostFromMapping> costFromMappings);

    /**
     * 添加系统配置的表单
     * @param systemFormInfo
     */
    void setSystemFormInfo(List<SystemConfig> systemFormInfo);

    boolean isRollback();

    /**
     * 获得当前工具类型
     * @return
     */
    FormType getFormType();

    /**
     * 获取个人抵扣的表数据
     * */
    //int getPersionCostById(String openId,Double money);
}
