package com.changhong.epc.form.service.budget.tool.impl;

import com.changhong.epc.constter.system.businesscode.BudgetBusinessMeaningCode;
import com.changhong.epc.form.service.budget.tool.IUpdateBudget;
import com.changhong.epc.form.service.budget.tool.entity.UpdateBudgetEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.data.redis.core.RedisTemplate;

import javax.annotation.Resource;

/**
 * 处理预算锁抽象类
 */
@Slf4j
public abstract class AbstractBudgetLock implements IUpdateBudget, BudgetBusinessMeaningCode {

    /**
     * 锁的key
     */
    public static final String FORMAT = "budgetLock_%d_%d_%d";

    /**
     * 锁的超时时间
     */
    public static final Long   LOCK_TIME    = 20000L;

    @Resource
    private RedisTemplate<String, Object> redisTemplate;

    private boolean isUpdate = false;

    /**
     * 添加锁
     * @param budgetChildId
     */
    protected void addLock(Integer budgetChildId){
        if(isUpdate){
            log.debug("当前修改，不加锁");
            return;
        }
//        String lockKey;
//        Boolean absent = redisTemplate.opsForValue().setIfAbsent(
//                lockKey = String.format(FORMAT, Context.getTenantId(), Context.getCompanyId(), budgetChildId)
//                , System.currentTimeMillis() + LOCK_TIME);
//        if(absent){
//            log.debug("添加锁成功");
//            return;
//        }
//        Long time = (Long)redisTemplate.opsForValue().get(lockKey);
//        log.debug("存在锁，锁超时时间:{}, 当前时间:{}", time, System.currentTimeMillis());
//        Assert.condition(time > System.currentTimeMillis(), BUDGET_LOCK);
//        delLock(budgetChildId);
//        addLock(budgetChildId);
    }

    /**
     * 删除锁
     * @param budgetChildId
     */
    protected void delLock(Integer budgetChildId){
//        redisTemplate.delete(String.format(FORMAT, Context.getTenantId(), Context.getCompanyId(), budgetChildId));
    }

    @Override
    public void updateBudget(UpdateBudgetEntity updateBudgetEntity) {
        this.isUpdate = true;
    }

}
