package com.changhong.epc.form.service.data;

import java.util.HashSet;
import java.util.List;
import java.util.Map;

import com.changhong.epc.bean.form.*;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.RequestBody;

import com.changhong.epc.bean.form.budget.addBudget.AddBudget;
import com.changhong.epc.bean.parsing.BillInfo;
import com.changhong.epc.form.service.budget.department.util.AddMoney;

import javax.servlet.http.HttpServletRequest;

public interface FormDataService {
	
	/**
	 * 追加预算检查上级预算余额
	 * @param addBudget
	 * @return Object
	 */
	public Object checkSuperBudgetMoney(AddBudget addBudget);
	
	int updataFormByCustom(String formName
							,int dataRowNum
							,Map<String, Object> fields);

	Object selectCountMoney(FormDataEntity formData);
	/**
	 * 修改状态上传票据,修改表单及票据
	 * @param billInfo
	 * @return int
	 */
	int updateFormAndBillInfo(BillInfo billInfo);
	
	/**
	 * 更新报销单状态
	 * @param formId
	 * @param dataRowNum
	 * @param status
	 * @return
	 */
	int updateExpendFormState(String voucherCode,String formId, int dataRowNum,Integer status,String tenantID);
	
	/**
	 * 查询表单数据
	 * 
	 */
	Map<String,Object> searchFormData(FormDataEntity formData);
	
	/**
	 * 查询预算子表单
	 * @param formData
	 * @param costType
	 * @return
	 */
	List<BugetSubForm> searchBudgetSubForm(FormDataEntity formData, HashSet<?> costType);
	
	/**
	 *  查询表数据
	 * @param formData
	 * @return
	 */
	List<Map<String, Object>> searchFormDataList(FormDataEntity formData);
	
	/**
	 * 查询追加（退回）预算表数据
	 * 
	 */
	List<AddMoney> searchExtendFormData(String formName,String parentDataRowNum, String dataRowNum);
	
	/**
	 * 查询一条上级预算
	 * 
	 */
	Map<String,Object> selectBudget(String orgs, String budget_itemCostType,String formName);
	
	/**
	 * 删除表单数据
	 * @return
	 */
	Integer deleteFormData(FormDataEntity formData); 
	
	/**
	 * 新增子表单数据
	 */
	List<Map<String,Object>> insertFormData(FormDataEntity formData);
	
	/**
	 * 修改表单数据（主，从）
	 */
	Integer updateFormData(FormDataEntity formData);
	
	/**
	 * 修改预算余额
	 * 
	 */
	 int updateItemBalance(AddMoney add,String formName);
	
	/**
	 * 查询符合条件的id
	 * @param formDate
	 * @param toData
	 * @param currency
	 * @return
	 */
	List<Integer> selectRangeByIds(String formName,String formDate, 
								String toData ,String budType,String currency,String occupy ,
								Integer pageNum, Integer pageSize
								,String budProject,String budDep);
	
	/**
	 * 
	 * @param formData
	 * @return
	 */
	public Map<String, Object> searchFormInfo1(FormDataEntity formData);
	
	
	/**
	 * 根据主表的id
	 * @param
	 * @param
	 * @return
	 */
	public List<Integer> selectMainIdBySubIds(String formId, String rowId);



/**
 * 修改未还金额/以还金额 
 */
	public int updaterepayment(String formName, Integer OutstandingAmount, Integer alreadyRepaid, Integer dataRowNum);

	/**
	 * 报销单检查数据
	 * @param
	 * @return
	 */
	String checkBugetData(CheckBuget checkBuget);
	
	/**
	 * 根据表单Id查询出一条dataRowNum
	 */
	int selectDataRowNum(Map<String,Object> map);

	/**
	 * 查询表单单条
	 * @param formDataEntity
	 * @return
	 */
	Map<String,Object> selectFormDataOne(FormDataEntity formDataEntity);
	
	int updateForm(FormDataEntity formData);
	
	Integer updateState(ProcessState process);
	
	ProcessState selectState(ProcessState process);
	
	/**
	 * 
	 * @param formData
	 * @return
	 */
	public Map<String, Object> searchFormInfo(FormDataEntity formData);
	
	/**
	 * 查询表单数据（函数使用）
	 * 
	 */
	Map<String,Object> searchFormData1(FormDataEntity formData);
	
	
	Object checkAsserFixedMoney(Map<String,String> map);
	
	/**
	 * 查询用户的申请单列表
	 */
	Object selectDatasByUserName(Map<String,String> map);
	
	/**
	 *通过报销单号查询报销单 
	 */
	Object selectBXByRow(Map <String ,String> map);

    /**
     * 自动修改
     */
    Integer updateSubFormDat(Map<String,Object> map);

	/**
	 * 表单固化
	 */
	String formSolidiFication(FormSolidiFication formSolidiFication);

	/**
	 * 查询所有申请单
	 */
	List<Map<String,Object>> selectApply(ApplyCostForm applyCostForm);
}