package com.changhong.epc.form.service.tenant.contract;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import com.changhong.epc.bean.form.contract.FormContract;
import com.changhong.epc.bean.form.contract.FormContractExtend;
import com.changhong.epc.bean.form.contract.FormContractPhase;


/**
 * 合同服务接口
 * @author liush
 *
 */
/**
 * @author liush
 *
 */
public interface FormContractService {
	
	/**
	 * 按倒序查询所有合同
	 * @param formContract
	 * @return
	 */
	List<FormContract> selectAllContract(FormContract formContract);
	
	/**
	 * 查询全部合同
	 * @return
	 */
	List<FormContract> selectAll();
	
	/**
	 * 查询单条合同
	 * @param formContract
	 * @return
	 */
	FormContract selectOne(FormContract formContract);
	
	/**
	 * 分页查询合同
	 * @param formContract
	 * @return
	 */
	List<FormContract> selectPage(FormContract formContract);
	
	/**
	 * 查询合同条数
	 * @param formContract
	 * @return
	 */
	Integer selectCount(FormContract formContract);
	
	/**
	 * 查询合同及其阶段信息
	 * @param formContract
	 * @return
	 */
//	List<FormContractExtend> selectAllContract(FormContract formContract);
	
	/**
	 * 插入合同
	 * @param formContract
	 * @return
	 */
	Integer insert(FormContract formContract);
	
	/**
	 * 更新合同（根据主键）
	 * @param formContract
	 * @return
	 */
	Integer updateByPrimaryKey(FormContract formContract);
	
	/**
	 * 删除合同
	 * @param formContract
	 * @return
	 */
	Integer delete(FormContract formContract);
	
	/**
	 * 插入合同信息（取得返回连接id）
	 * @param formContract
	 * @return
	 */
	Integer formContractSave(FormContractExtend formContractExtend);
	
	/**
	 * 插入合同及其阶段信息
	 * @param formContract
	 * @param formContractPhase
	 * @return
	 */
	Integer save(FormContractExtend formContractExtend);
	
}
