package com.changhong.epc.form.service.tenant.contract.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.changhong.autoform.entity.ProcessBudget;
import com.changhong.epc.bean.form.contract.FormContractPhase;
import com.changhong.epc.constter.system.businesscode.BudgetBusinessMeaningCode;
import com.changhong.epc.form.execute.IFormOthersOperation;
import com.changhong.epc.form.mapper.tenant.FormDataMapper;
import com.changhong.epc.form.mapper.tenant.contract.FormContractPhaseMapper;
import com.changhong.epc.form.service.budget.department.model.BudgetRow;
import com.changhong.epc.form.service.budget.department.model.BudgetRowUpdateRecord;
import com.changhong.epc.form.service.budget.department.util.ContractStage;
import com.changhong.epc.form.service.budget.impl.GetConstant;
import com.changhong.epc.form.service.tenant.contract.FormContractPhaseService;
import com.iemsoft.framework.cloud.core.exception.IEMRestException;
import com.iemsoft.framework.cloud.core.tools.JSONTool;
import com.iemsoft.framework.cloud.core.tools.SpringUtil;

import lombok.extern.slf4j.Slf4j;
@Slf4j
@Service("formContractPhaseService")
public class FormContractPhaseServiceImpl implements FormContractPhaseService,BudgetBusinessMeaningCode {
	
	
	
	
	/**
	 * 取出表单
	 */
	@Resource
	private IFormOthersOperation formOthersOperation;
	
	/**
	 * 取上级预算
	 */
	//private IFormOthersOperation formOthersOperationHig = SpringUtil.getBean(IFormOthersOperation.class);

	
	
	@Resource
	private FormContractPhaseMapper formContractPhaseMapper;
	
	@Override
	public List<FormContractPhase> selectAll() {
		return formContractPhaseMapper.selectAll();
	}
	
	@Override
	public FormContractPhase selectOne(FormContractPhase formContractPhase) {
		return formContractPhaseMapper.selectOne(formContractPhase);
	}
	
	@Override
	public Integer selectCount(FormContractPhase formContractPhase) {
		return formContractPhaseMapper.selectCount(formContractPhase);
	}
	
	@Override
	public List<FormContractPhase> select(FormContractPhase formContractPhase) {
		return formContractPhaseMapper.select(formContractPhase);
	}
	
	@Override
	public Integer insert(FormContractPhase formContractPhase) {
		return formContractPhaseMapper.insert(formContractPhase);
	}
	
	public Integer updateByPrimaryKey(FormContractPhase formContractPhase) {
		return formContractPhaseMapper.updateByPrimaryKey(formContractPhase);
	}
	
	
//	/**
//	 * 合同报销占用付款阶段
//	 */
//	@Override
//	public Integer contractBud(ProcessBudget processBudget) {
//		int flag = 0;
//		//当前报销单
//		Map<String, Object> fromInfo = formOthersOperation.selectFormDataInfo(processBudget);
//		log.debug("当前单据:"+JSONTool.toJson(fromInfo));
//		//上级预算单
//		flag = contractBudget(fromInfo,new ProcessBudget());
//		return flag;
//	}
//	
//	/**
//	 * 占用预算1
//	 */
//	public int contractBudget(Map<String, Object> fromInfo, ProcessBudget processBudget){
//		// System.out.println("参数:"+JSONTool.toJson(fromInfo));
//		processBudget.setAlias(BUDGET_SUB_FROM);
//		processBudget.setFormId(GetConstant.getFormIdGetConstant(YS_FORMID));
//		if(fromInfo.get(TO_WRITE_BUDGET).toString().contains(",")){
//			return -1;
//		}
//		processBudget.setDataRowNUm(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));
//		Map<String,Object> subData =  formOthersOperation.getFromInfo(processBudget);
//		BudgetRow budgetRow =  new BudgetRow();
//		budgetRow.setDataRowNumber(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));
//		budgetRow.setBalance(subData.get(BUDGET_ITEM_BALANCE).toString());
//		budgetRow.setMoney(money(fromInfo));
//		verify(budgetRow).forEach(o->{
//			formOthersOperation.updateFormFieldProperty(o.getProcessBudget(), o.getData());
//		});
//		
//		//getPrice(formInfo,new ProcessBudget);
//		return 1;
//	}
//	
//	/**
//	 * 取出金额种类
//	 * @param map
//	 * @return
//	 */
//	private static String money(Map<String,Object> map){
//		Object ysm = map.get(BUDGET_ITEM_MONEY);
//		if(ysm != null)
//			return Objects.toString(ysm,"0");
//		ysm = map.get(APPLY_USE_MONEY);
//		if(ysm != null)
//			return Objects.toString(ysm,"0");
//		ysm = map.get(EXPEND_USE_MONEY);
//		if(ysm != null)
//			return Objects.toString(ysm,"0");
//		return "0";
//	}
//	
//	/**
//	 * 预算是否充足
//	 */
//	public List<BudgetRowUpdateRecord> verify(BudgetRow budgetRow){
//		List<BudgetRowUpdateRecord> budgetRowRecord = new ArrayList<>();
//		Double applyMoney = Double.valueOf(budgetRow.getMoney());
//		Double balance = Double.valueOf(budgetRow.getBalance());
//		Double money  =  balance - applyMoney;
//		if(money < 0){
//			throw new IEMRestException("预算不足");
//		}
//		budgetRowRecord.add(new BudgetRowUpdateRecord(
//				new ProcessBudget(GetConstant.getFormIdGetConstant(YS_FORMID)
//						, budgetRow.getDataRowNumber(), BUDGET_SUB_FROM)
//				, BUDGET_ITEM_BALANCE, money + ""));
//		return budgetRowRecord;
//	}
//	
//	/**
//	 * 返回当前报销单子表单阶段
//	 */
//	public Map<String,Object> getPrice(Map<String, Object> fromInfo,String formId){
//	//processBudget.setDataRowNUm(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));
//		Map<String,Object> subData =  formOthersOperation.getFromInfo(processBudget);
//		// System.out.println("返回当前报销单子表单阶段结果:"+JSONTool.toJson(subData));
//		return subData;
//	}
	
//	/**
//	 * 返回当前合同所有阶段
//	 */
//	public Integer getContract(Map<String, Object> fromInfo, ProcessBudget process){
//		ProcessBudget processBudget = new ProcessBudget();
//		boolean flag = false;
//		processBudget.setAlias(BUDGET_SUB_FROM);
//		processBudget.setFormId(GetConstant.getFormIdGetConstant(process.getFormId()));
//		if(fromInfo.get(TO_WRITE_BUDGET).toString().contains(",")){
//			return false;
//		}
//		//processBudget.setDataRowNUm(Integer.parseInt(fromInfo.get(TO_WRITE_BUDGET).toString()));
//		Map<String,Object> subData =  formMapper.selectSonForm(
//					getTableName(process.getFormId(),process.getTenantID()),
//						);
//		// System.out.println("返回结果:"+JSONTool.toJson(subData));
//		return flag;
//	}
	
//	/**
//	 * 表名拼接
//	 */
//	public String getTableName(String formId,String tenantID){
//		return "formdata_"+tenantID+"_"+formId+"_"+BUDGET_SUB_FROM;
//	}
//
//	@Resource
//	private FormDataMapper formMapper;
//	
//	@Override
//	public int select(ContractStage name, int a) {
//		String as = "formdata_001_96cecf4c7a690743db7a8667614f_budget_subfrom";
//		
//		return formMapper.updateContract(name, as);
//	}
//	
	
}
