package com.changhong.epc.form.service.tenant.contract.impl;

import com.changhong.epc.bean.form.contract.FormContract;
import com.changhong.epc.bean.form.contract.FormContractExtend;
import com.changhong.epc.bean.form.contract.FormContractPhase;
import com.changhong.epc.form.mapper.tenant.contract.FormContractMapper;
import com.changhong.epc.form.mapper.tenant.contract.FormContractPhaseMapper;
import com.changhong.epc.form.service.tenant.contract.FormContractService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

/**
 * 合同服务接口实现层
 * @author liush
 *
 */
@Service("formContractService")
public class FormContractServiceImpl implements FormContractService {
	
	@Resource
	private FormContractMapper formContractMapper;
	
	@Resource
	private FormContractPhaseMapper formContractPhaseMapper;
	
	@Override
	public List<FormContract> selectAllContract(FormContract formContract) {
		return formContractMapper.selectAllContract(formContract);
	}
	
	@Override
	public List<FormContract> selectAll() {
		return formContractMapper.selectAll();
	}
	
	@Override
	public FormContract selectOne(FormContract formContract) {
		return formContractMapper.selectOne(formContract);
	}
	
	@Override
	public List<FormContract> selectPage(FormContract formContract) {
		return formContractMapper.selectPage(formContract);
	}
	
	@Override
	public Integer selectCount(FormContract formContract){
		return formContractMapper.selectCount(formContract);
	}
	
	@Override
	public Integer insert(FormContract formContract) {
		return formContractMapper.insert(formContract);
	}
	
	@Override
	public Integer updateByPrimaryKey(FormContract formContract) {
		return formContractMapper.updateByPrimaryKey(formContract);
	}
	
	@Override
	public Integer delete(FormContract formContract) {
		return formContractMapper.delete(formContract);
	}
	
	@Transactional
	@Override
	public Integer formContractSave(FormContractExtend formContractExtend) {
		return formContractMapper.formContractSave(formContractExtend);
	}
	
	@Transactional
	@Override
	public Integer save(FormContractExtend formContractExtend) {
		int count = formContractMapper.formContractSave(formContractExtend);
		if(count > 0) {
			for (FormContractPhase a : formContractExtend.getFormContractPhaseList()) {
				a.setContractId(formContractExtend.getId());
				formContractPhaseMapper.insert(a);
			}
		}
		return count;
	}

	
	
//	@Override
//	public List<FormContractExtend> selectAllContract(FormContract formContract) {
//		return formContractMapper.selectAllContract(formContract);
//	}
	

	
	
}
