package com.changhong.epc.form.tool;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;
import org.springframework.ui.ModelMap;

import com.alibaba.druid.util.StringUtils;
import com.changhong.epc.bean.form.FormDataEntity;
import com.changhong.epc.bean.form.ReleData;
import com.changhong.epc.form.service.data.FormDataService;
import com.changhong.epc.form.service.field.FormFieldService;
import com.iemsoft.framework.cloud.core.tools.ObjectUtil;


@Component
public class GetReleData {
	
	@Resource
	private FormDataService formDataService;
	
	@Resource
	private FormFieldService formFieldService;
	
	private Map<String ,Object> nowData;
	
	public ReleData GetData(String tenantId, String formId, Integer dataRowNum, String alias){
		FormDataEntity formData = new FormDataEntity();
		formData.setFormId(formId);
		formData.setDataRowNum(dataRowNum);
		formData.setTenantId(tenantId);
		 Map<String ,Object> queryNowData = formDataService.searchFormInfo(formData);
		if(ObjectUtil.notEmpty(queryNowData)){
			Object ob = queryNowData.get(alias);
			this.nowData = queryNowData;
			//dataRowNum 
			String reNumber = ob.toString();
			List<Map<String,Object>> subs = formFieldService.getFormHaveSub(new ModelMap("formID", formId).addAttribute("tenantID", tenantId));
			if( subs != null && !subs.isEmpty()){
				Iterator<String> it = subs.get(0).keySet().iterator();
				while(it.hasNext()){
					formData.setChildAlias(it.next());
					break;
				}
			}
			String reFormID = formFieldService.getAssFormId(new ModelMap("formID", formId)
																.addAttribute("tenantID", tenantId).addAttribute("alias", alias));
			if(StringUtils.isEmpty(reFormID))
				return null;
			
			formData.setFormId(reFormID);
			ReleData result= new ReleData();
			result.setReleFormID(reFormID);
			if(reNumber.contains(",")){//还没完全实现
				String [] res = reNumber.split(",");
				for(String number :res){//未完全实现
					formData.setDataRowNum(Integer.parseInt(number));
					result.setChooseData(formDataService.searchFormData(formData));
				}
			}else{
				formData.setDataRowNum(Integer.parseInt(reNumber));
				result.setChooseData(formDataService.searchFormData(formData));
			}
			return result;
		}
		return null;
		
	}

	public Map<String, Object> getNowData() {
		return nowData;
	}

}
